config/routes.rb
# frozen_string_literal: true

require "sidekiq/web"

Rails.application.routes.draw do
  # Administrate
  constraints CanAccessAdmin do
    namespace :admin do
      root controller: "users", action: :index
      resources :users do
        post :impersonate, on: :member
      end
      get :stop_impersonating, to: :stop_impersonating, controller: "users"
      mount Flipper::UI.app(Flipper) => "/flipper", as: "flipper"
      mount Sidekiq::Web => "/sidekiq", as: "sidekiq"
      mount LetterOpenerWeb::Engine, at: "/letter_opener", as: "letters" if Rails.env.development?
    end
  end

  mount StripeEvent::Engine, at: "/stripe/webhook"

  devise_for :users,  path: "",
                      path_names: {
                        sign_in: "sign-in",
                        sign_out: "sign-out",
                        sign_up: "sign-up"
                      },
                      controllers: {
                        registrations: "users/registrations"
                      }

  unauthenticated :user do
    devise_scope :user do
      root to: "pages#features"
    end
  end

  # Signed out (marketing) pages
  get "pricing", to: "pages#pricing"
  get "about", to: "pages#about"
  get "cancelled", to: "pages#cancelled"

  # Signed in pages
  authenticated :user do
    root to: "dashboard#show", as: "dashboard"
    get "pro", to: "pages#pro"
  end

  # Avatars
  patch "avatars", to: "avatars#update"
  delete "avatar", to: "avatars#destroy"

  # Subscription stuff
  get "billing", to: "subscriptions#show"
  get "subscribe", to: "subscriptions#new"
  patch "subscriptions", to: "subscriptions#update"
end

app/views/layouts/_navbar_loggedin.haml
%nav.navbar.navbar-expand-sm.navbar-light.bg-light.navbar-fixed-top
  .container
    = link_to "Limestone", "/", class: "navbar-brand"
    %button.navbar-toggler{type: "button", data: { toggle: "collapse", target:"#nav_loggedin" }}
      %span.navbar-toggler-icon
    #nav_loggedin.collapse.navbar-collapse
      %ul.navbar-nav.mr-auto
        %li.nav-item= link_to "Dashboard", dashboard_path, class: "nav-link"
        - if current_user.product.pro?
          %li.nav-item= link_to "Pro Page", pro_path, class: "nav-link"
      %ul.navbar-nav.ml-auto
        .li.nav-item.dropdown
          = link_to avatar(current_user, :sm), "#", {"data-toggle": "dropdown", role: "button", "aria-haspopup": true, "aria-expanded": false}
          .dropdown-menu.dropdown-menu-right
            = link_to "Account", edit_user_registration_path, class: "dropdown-item"
            - if current_user.admin?
              = link_to "Admin", admin_root_path, class: "dropdown-item"
            - else
              = current_user.sub_active? ? link_to("Billing", billing_path, class: "dropdown-item") : link_to("Subscribe ", subscribe_path, class: "dropdown-item")
            .dropdown-divider
            = link_to "Stop Impersonating", admin_stop_impersonating_path, class: "dropdown-item" if current_user != true_user
            = link_to "Logout", main_app.destroy_user_session_path, class: "dropdown-item"

app/views/layouts/_navbar_loggedout.haml
%nav.navbar.navbar-expand-lg.navbar-light.bg-light.navbar-fixed-top
  .container
    = link_to "Limestone", "/", class: "navbar-brand"
    %button.navbar-toggler{type: "button", data: { toggle: "collapse", target:"#navbar_loggedout" }}
      %span.navbar-toggler-icon
    #nav_loggedout.collapse.navbar-collapse
      %ul.navbar-nav.mr-auto
        %li.nav-item
          = link_to "Pricing", pricing_path, class: "nav-link"
        %li.nav-item
          = link_to "About", about_path, class: "nav-link"
      .form
        = link_to "Sign up", main_app.new_user_registration_path, class: "btn btn-success" if Flipper.enabled?(:public_registration)
        = link_to "Sign in", main_app.new_user_session_path, class: "btn btn-primary"

app/views/layouts/_past_due.haml
.alert.alert-danger.alert-banner{role: 'alert'}<
  Your account is past due. Please
  = link_to 'ensure you have a valid card', billing_path
  \. We will attempt payment shortly after you update it.

app/views/layouts/application.haml
!!!
%html
  %head
    %title Limestone
    %meta{ content: "text/html; charset=UTF-8", "http-equiv": "Content-Type" }
    %meta{ name: "viewport", content: "width=device-width, initial-scale=1" }
    %meta{ "http-equiv": "x-ua-compatible", content: "ie=edge" }
    = action_cable_meta_tag
    = tag :meta, name: "stripe-key", content: Pay::Stripe.public_key
    -# Webpacker application.js
    = javascript_pack_tag "application", "data-turbolinks-track": "reload"
    -# Webpacker application.css
    = stylesheet_pack_tag 'application'
    = javascript_include_tag "https://js.stripe.com/v3/"
    = csrf_meta_tags
  %body{ turbolinks? }
    = render "layouts/past_due" if user_signed_in? && !current_user.sub_active_or_trialing?
    .mb-2
      = render user_signed_in? ? "layouts/navbar_loggedin" : "layouts/navbar_loggedout"
    .container
      - flash.each do |name, msg|
        - if msg.is_a?(String)
          .alert.alert-dismissible{class: "alert-#{name}", role: "alert"}
            %button.close{type: "button", "data-dismiss": "alert", "aria-label": "Close"}
              %span{"aria-hidden": true} &times;
            = msg
      = yield